List all of the projects in the supplied Octopus Deploy Space, from all project groups. The results will be sorted alphabetically by name
GET /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
Query Parameters
clonedFromProjectIdstringidsarray of stringnamestring
(Obsolete) A partial or complete name to limit the set of retrieved Projects to. This will perform a “contains” style match against the supplied name or name-fragment. Left for backwards compatibility.partialNamestring
A partial name, to limit the set of Projects to those with a name that includes the partial name.skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 30. Minimum0.
Response
200 — List all of the projects in the supplied Octopus Deploy Space, from all project groups. The results will be sorted alphabetically by name.
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectAllowIgnoreChannelRulesbooleanAutoCreateReleasebooleanAutoDeployReleaseOverridesarray of objectClonedFromProjectIdstringCombineHealthAndSyncStatusInDashboardLiveStatusbooleanDefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultPowerShellEditionstringDefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringDeploymentProcessIdstringDeprovisioningRunbookIdstringDescriptionstringDiscreteChannelReleaseboolean
Treats releases of different channels to the same environment as a seperate deployment dimension. ‘False’ indicates a “hotfix”-style usage of channels (single release active per environment ignoring channels), whereasTrueindicates “microservice”-style usage (single release per environment per channel).ExecuteDeploymentsOnEventBasedPipelinebooleanExtensionSettingsarray of objectForcePackageDownloadbooleanIconobjectIdstring
Gets or sets a unique identifier for this resource.IncludedLibraryVariableSetIdsarray of string
Library variable sets included in the project. Sets are listed in order of precedence, with earlier items in the list overriding any variables with the same name and scope definition appearing later in the list.IsBadgesEnabledbooleanIsDisabledbooleanIsVersionControlledbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LifecycleIdstringLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NamestringPersistenceSettingsobjectProjectConnectivityPolicyobjectProjectGroupIdstringProjectTagsarray of string
List of tags assigned to this project.ProjectTemplateDetailsobjectProvisioningRunbookIdstringReleaseCreationStrategyobjectReleaseNotesTemplatestringSlugstringSpaceIdstringTemplatesarray of objectTenantedDeploymentModeenum
Allowed values:Untenanted,TenantedOrUntenanted,Tenanted.VariableSetIdstringVersioningStrategyobject
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"AllowIgnoreChannelRules": true,
"AutoCreateRelease": true,
"AutoDeployReleaseOverrides": [
{}
],
"ClonedFromProjectId": "Projects-1",
"CombineHealthAndSyncStatusInDashboardLiveStatus": true,
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultPowerShellEdition": "string",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"DeploymentProcessId": "string",
"DeprovisioningRunbookId": "Runbooks-1",
"Description": "string",
"DiscreteChannelRelease": true,
"ExecuteDeploymentsOnEventBasedPipeline": true,
"ExtensionSettings": [
{}
],
"ForcePackageDownload": true,
"Icon": {
"Color": "string",
"Id": "string"
},
"Id": "string",
"IncludedLibraryVariableSetIds": [
"string"
],
"IsBadgesEnabled": true,
"IsDisabled": true,
"IsVersionControlled": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LifecycleId": "string",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"PersistenceSettings": {
"Type": "Database"
},
"ProjectConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"ProjectGroupId": "string",
"ProjectTags": [
"string"
],
"ProjectTemplateDetails": {
"IsShared": true,
"Slug": "string",
"VersionMask": "string"
},
"ProvisioningRunbookId": "Runbooks-1",
"ReleaseCreationStrategy": {
"ChannelId": "string",
"ReleaseCreationPackage": {}
},
"ReleaseNotesTemplate": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Templates": [
{}
],
"TenantedDeploymentMode": "Untenanted",
"VariableSetId": "string",
"VersioningStrategy": {
"DonorPackage": {},
"Template": "string"
}
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Create a new project
POST /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
Request Body
AllowIgnoreChannelRulesbooleanAutoCreateReleasebooleanAutoDeployReleaseOverridesarray of objectEnvironmentIdstringReleaseIdstringTenantIdstring
Clonestring
ID of an existing project in the same space whose configuration (deployment process, variables, channels, runbooks, triggers) is copied into the new project. The source project must store its configuration in the database, not Git.CombineHealthAndSyncStatusInDashboardLiveStatusbooleanDefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringDescriptionstringDiscreteChannelReleaseboolean
Treats releases of different channels to the same environment as a seperate deployment dimension. ‘False’ indicates a “hotfix”-style usage of channels (single release active per environment ignoring channels), whereasTrueindicates “microservice”-style usage (single release per environment per channel).ExecuteDeploymentsOnEventBasedPipelinebooleanExtensionSettingsarray of objectExtensionIdstringValuesstring
ForcePackageDownloadbooleanIncludedLibraryVariableSetIdsarray of string
Library variable sets included in the project. Sets are listed in order of precedence, with earlier items in the list overriding any variables with the same name and scope definition appearing later in the list.IsDisabledbooleanLifecycleIdstring (required)Namestring (required)
Minimum length 1.PersistenceSettingsobjectTypeenum
Allowed values:Database,VersionControlled.
ProjectConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
ProjectGroupIdstring (required)ProjectTagsarray of string
Tags to apply to the project, each written as “TagSet/Tag” using either the names or the IDs of the tag set and tag (for example “Regions/us-east”). Call find_tag_sets to discover which tag sets apply to projects and what tags they contain.ReleaseCreationStrategyobjectChannelIdstringReleaseCreationPackageobject
ReleaseNotesTemplatestringRetainTenantConnectionsboolean
When cloning, copy the source project’s tenant connections to the new project. Only honoured when Clone is set. Defaults to false.Slugstring
URL-friendly short identifier for the project, unique within the space (for example “web-store”). Leave unset to have one generated from the name.SpaceIdstring (required)Templatesarray of objectDefaultValueobjectDisplaySettingsobjectHelpTextstringIdstringLabelstringNamestring
TenantedDeploymentModeenum
Allowed values:Untenanted,TenantedOrUntenanted,Tenanted.VersioningStrategyobjectDonorPackageobjectTemplatestring
Response
201 — Created
AllowIgnoreChannelRulesbooleanAutoCreateReleasebooleanAutoDeployReleaseOverridesarray of objectEnvironmentIdstringReleaseIdstringTenantIdstring
ClonedFromProjectIdstringCombineHealthAndSyncStatusInDashboardLiveStatusbooleanDefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultPowerShellEditionstringDefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringDeploymentProcessIdstringDeprovisioningRunbookIdstringDescriptionstringDiscreteChannelReleaseboolean
Treats releases of different channels to the same environment as a seperate deployment dimension. ‘False’ indicates a “hotfix”-style usage of channels (single release active per environment ignoring channels), whereasTrueindicates “microservice”-style usage (single release per environment per channel).ExecuteDeploymentsOnEventBasedPipelinebooleanExtensionSettingsarray of objectExtensionIdstringValuesstring
ForcePackageDownloadbooleanIconobjectColorstring
Icon background colour, as a Hex string.Idstring
Font Awesome Icon Id.
Idstring
Gets or sets a unique identifier for this resource.IncludedLibraryVariableSetIdsarray of string
Library variable sets included in the project. Sets are listed in order of precedence, with earlier items in the list overriding any variables with the same name and scope definition appearing later in the list.IsBadgesEnabledbooleanIsDisabledbooleanIsVersionControlledbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LifecycleIdstringLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NamestringPersistenceSettingsobjectTypeenum
Allowed values:Database,VersionControlled.
ProjectConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
ProjectGroupIdstringProjectTagsarray of string
List of tags assigned to this project.ProjectTemplateDetailsobjectIsSharedbooleanSlugstringVersionMaskstring
Minimum length 1.
ProvisioningRunbookIdstringReleaseCreationStrategyobjectChannelIdstringReleaseCreationPackageobject
ReleaseNotesTemplatestringSlugstringSpaceIdstringTemplatesarray of objectDefaultValueobjectDisplaySettingsobjectHelpTextstringIdstringLabelstringNamestring
TenantedDeploymentModeenum
Allowed values:Untenanted,TenantedOrUntenanted,Tenanted.VariableSetIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Request
{
"AllowIgnoreChannelRules": true,
"AutoCreateRelease": true,
"AutoDeployReleaseOverrides": [
{
"EnvironmentId": "string",
"ReleaseId": "string",
"TenantId": "Tenants-1"
}
],
"Clone": "Projects-1",
"CombineHealthAndSyncStatusInDashboardLiveStatus": true,
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"Description": "string",
"DiscreteChannelRelease": true,
"ExecuteDeploymentsOnEventBasedPipeline": true,
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"ForcePackageDownload": true,
"IncludedLibraryVariableSetIds": [
"string"
],
"IsDisabled": true,
"LifecycleId": "Lifecycles-1",
"Name": "string",
"PersistenceSettings": {
"Type": "Database"
},
"ProjectConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"ProjectGroupId": "ProjectGroups-1",
"ProjectTags": [
"string"
],
"ReleaseCreationStrategy": {
"ChannelId": "string",
"ReleaseCreationPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
}
},
"ReleaseNotesTemplate": "string",
"RetainTenantConnections": true,
"Slug": "string",
"SpaceId": "Spaces-1",
"Templates": [
{
"DefaultValue": {
"IsSensitive": true,
"SensitiveValue": {},
"Value": "string"
},
"DisplaySettings": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"HelpText": "string",
"Id": "string",
"Label": "string",
"Name": "string"
}
],
"TenantedDeploymentMode": "Untenanted",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Example Response
{
"AllowIgnoreChannelRules": true,
"AutoCreateRelease": true,
"AutoDeployReleaseOverrides": [
{
"EnvironmentId": "string",
"ReleaseId": "string",
"TenantId": "Tenants-1"
}
],
"ClonedFromProjectId": "Projects-1",
"CombineHealthAndSyncStatusInDashboardLiveStatus": true,
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultPowerShellEdition": "string",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"DeploymentProcessId": "string",
"DeprovisioningRunbookId": "Runbooks-1",
"Description": "string",
"DiscreteChannelRelease": true,
"ExecuteDeploymentsOnEventBasedPipeline": true,
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"ForcePackageDownload": true,
"Icon": {
"Color": "string",
"Id": "string"
},
"Id": "string",
"IncludedLibraryVariableSetIds": [
"string"
],
"IsBadgesEnabled": true,
"IsDisabled": true,
"IsVersionControlled": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LifecycleId": "string",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"PersistenceSettings": {
"Type": "Database"
},
"ProjectConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"ProjectGroupId": "string",
"ProjectTags": [
"string"
],
"ProjectTemplateDetails": {
"IsShared": true,
"Slug": "string",
"VersionMask": "string"
},
"ProvisioningRunbookId": "Runbooks-1",
"ReleaseCreationStrategy": {
"ChannelId": "string",
"ReleaseCreationPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
}
},
"ReleaseNotesTemplate": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Templates": [
{
"DefaultValue": {
"IsSensitive": true,
"SensitiveValue": {},
"Value": "string"
},
"DisplaySettings": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"HelpText": "string",
"Id": "string",
"Label": "string",
"Name": "string"
}
],
"TenantedDeploymentMode": "Untenanted",
"VariableSetId": "string",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}List all of the projects in the supplied Octopus Deploy Space
GET /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
ID of the space.
Query Parameters
idsarray of string
Project Ids of Projects to filter results to.
Response
200 — All of the project resources in the supplied Octopus Deploy Space.
AllowIgnoreChannelRulesbooleanAutoCreateReleasebooleanAutoDeployReleaseOverridesarray of objectEnvironmentIdstringReleaseIdstringTenantIdstring
ClonedFromProjectIdstringCombineHealthAndSyncStatusInDashboardLiveStatusbooleanDefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultPowerShellEditionstringDefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringDeploymentProcessIdstringDeprovisioningRunbookIdstringDescriptionstringDiscreteChannelReleaseboolean
Treats releases of different channels to the same environment as a seperate deployment dimension. ‘False’ indicates a “hotfix”-style usage of channels (single release active per environment ignoring channels), whereasTrueindicates “microservice”-style usage (single release per environment per channel).ExecuteDeploymentsOnEventBasedPipelinebooleanExtensionSettingsarray of objectExtensionIdstringValuesstring
ForcePackageDownloadbooleanIconobjectColorstring
Icon background colour, as a Hex string.Idstring
Font Awesome Icon Id.
Idstring
Gets or sets a unique identifier for this resource.IncludedLibraryVariableSetIdsarray of string
Library variable sets included in the project. Sets are listed in order of precedence, with earlier items in the list overriding any variables with the same name and scope definition appearing later in the list.IsBadgesEnabledbooleanIsDisabledbooleanIsVersionControlledbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LifecycleIdstringLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NamestringPersistenceSettingsobjectTypeenum
Allowed values:Database,VersionControlled.
ProjectConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
ProjectGroupIdstringProjectTagsarray of string
List of tags assigned to this project.ProjectTemplateDetailsobjectIsSharedbooleanSlugstringVersionMaskstring
Minimum length 1.
ProvisioningRunbookIdstringReleaseCreationStrategyobjectChannelIdstringReleaseCreationPackageobject
ReleaseNotesTemplatestringSlugstringSpaceIdstringTemplatesarray of objectDefaultValueobjectDisplaySettingsobjectHelpTextstringIdstringLabelstringNamestring
TenantedDeploymentModeenum
Allowed values:Untenanted,TenantedOrUntenanted,Tenanted.VariableSetIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Response
[
{
"AllowIgnoreChannelRules": true,
"AutoCreateRelease": true,
"AutoDeployReleaseOverrides": [
{
"EnvironmentId": "string",
"ReleaseId": "string",
"TenantId": "Tenants-1"
}
],
"ClonedFromProjectId": "Projects-1",
"CombineHealthAndSyncStatusInDashboardLiveStatus": true,
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultPowerShellEdition": "string",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"DeploymentProcessId": "string",
"DeprovisioningRunbookId": "Runbooks-1",
"Description": "string",
"DiscreteChannelRelease": true,
"ExecuteDeploymentsOnEventBasedPipeline": true,
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"ForcePackageDownload": true,
"Icon": {
"Color": "string",
"Id": "string"
},
"Id": "string",
"IncludedLibraryVariableSetIds": [
"string"
],
"IsBadgesEnabled": true,
"IsDisabled": true,
"IsVersionControlled": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LifecycleId": "string",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"PersistenceSettings": {
"Type": "Database"
},
"ProjectConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"ProjectGroupId": "string",
"ProjectTags": [
"string"
],
"ProjectTemplateDetails": {
"IsShared": true,
"Slug": "string",
"VersionMask": "string"
},
"ProvisioningRunbookId": "Runbooks-1",
"ReleaseCreationStrategy": {
"ChannelId": "string",
"ReleaseCreationPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
}
},
"ReleaseNotesTemplate": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Templates": [
{
"DefaultValue": {},
"DisplaySettings": {},
"HelpText": "string",
"Id": "string",
"Label": "string",
"Name": "string"
}
],
"TenantedDeploymentMode": "Untenanted",
"VariableSetId": "string",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}
]Get the logo associated with the project
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the resource.spaceIdstring (required)
ID of the space.
Response
200 — Success
Example Response
"string"Get a Project by ID or slug
GET /api
Also reachable at /api, /api, /api, /api, /api.
Path Parameters
projectIdstring (required)
ID of the Project to return.spaceIdstring (required)
Response
200 — The requested Project.
AllowIgnoreChannelRulesbooleanAutoCreateReleasebooleanAutoDeployReleaseOverridesarray of objectEnvironmentIdstringReleaseIdstringTenantIdstring
ClonedFromProjectIdstringCombineHealthAndSyncStatusInDashboardLiveStatusbooleanDefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultPowerShellEditionstringDefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringDeploymentProcessIdstringDeprovisioningRunbookIdstringDescriptionstringDiscreteChannelReleaseboolean
Treats releases of different channels to the same environment as a seperate deployment dimension. ‘False’ indicates a “hotfix”-style usage of channels (single release active per environment ignoring channels), whereasTrueindicates “microservice”-style usage (single release per environment per channel).ExecuteDeploymentsOnEventBasedPipelinebooleanExtensionSettingsarray of objectExtensionIdstringValuesstring
ForcePackageDownloadbooleanIconobjectColorstring
Icon background colour, as a Hex string.Idstring
Font Awesome Icon Id.
Idstring
Gets or sets a unique identifier for this resource.IncludedLibraryVariableSetIdsarray of string
Library variable sets included in the project. Sets are listed in order of precedence, with earlier items in the list overriding any variables with the same name and scope definition appearing later in the list.IsBadgesEnabledbooleanIsDisabledbooleanIsVersionControlledbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LifecycleIdstringLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NamestringPersistenceSettingsobjectTypeenum
Allowed values:Database,VersionControlled.
ProjectConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
ProjectGroupIdstringProjectTagsarray of string
List of tags assigned to this project.ProjectTemplateDetailsobjectIsSharedbooleanSlugstringVersionMaskstring
Minimum length 1.
ProvisioningRunbookIdstringReleaseCreationStrategyobjectChannelIdstringReleaseCreationPackageobject
ReleaseNotesTemplatestringSlugstringSpaceIdstringTemplatesarray of objectDefaultValueobjectDisplaySettingsobjectHelpTextstringIdstringLabelstringNamestring
TenantedDeploymentModeenum
Allowed values:Untenanted,TenantedOrUntenanted,Tenanted.VariableSetIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Response
{
"AllowIgnoreChannelRules": true,
"AutoCreateRelease": true,
"AutoDeployReleaseOverrides": [
{
"EnvironmentId": "string",
"ReleaseId": "string",
"TenantId": "Tenants-1"
}
],
"ClonedFromProjectId": "Projects-1",
"CombineHealthAndSyncStatusInDashboardLiveStatus": true,
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultPowerShellEdition": "string",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"DeploymentProcessId": "string",
"DeprovisioningRunbookId": "Runbooks-1",
"Description": "string",
"DiscreteChannelRelease": true,
"ExecuteDeploymentsOnEventBasedPipeline": true,
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"ForcePackageDownload": true,
"Icon": {
"Color": "string",
"Id": "string"
},
"Id": "string",
"IncludedLibraryVariableSetIds": [
"string"
],
"IsBadgesEnabled": true,
"IsDisabled": true,
"IsVersionControlled": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LifecycleId": "string",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"PersistenceSettings": {
"Type": "Database"
},
"ProjectConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"ProjectGroupId": "string",
"ProjectTags": [
"string"
],
"ProjectTemplateDetails": {
"IsShared": true,
"Slug": "string",
"VersionMask": "string"
},
"ProvisioningRunbookId": "Runbooks-1",
"ReleaseCreationStrategy": {
"ChannelId": "string",
"ReleaseCreationPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
}
},
"ReleaseNotesTemplate": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Templates": [
{
"DefaultValue": {
"IsSensitive": true,
"SensitiveValue": {},
"Value": "string"
},
"DisplaySettings": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"HelpText": "string",
"Id": "string",
"Label": "string",
"Name": "string"
}
],
"TenantedDeploymentMode": "Untenanted",
"VariableSetId": "string",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Modify an existing Project
PUT /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)
ID of the project to modify.spaceIdstring (required)
Request Body
AllowIgnoreChannelRulesbooleanAutoCreateReleasebooleanAutoDeployReleaseOverridesarray of objectEnvironmentIdstringReleaseIdstringTenantIdstring
ChangeDescriptionstring
The change description.ClonedFromProjectIdstringCombineHealthAndSyncStatusInDashboardLiveStatusbooleanDefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultPowerShellEditionstring
Which edition of PowerShell the project’s script steps run under: “Desktop” (Windows PowerShell) or “Core” (cross-platform PowerShell). Leave unset to inherit the server default.DefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringDeprovisioningRunbookIdstring
ID of a runbook in this project that tears down an ephemeral environment. Must be an existing runbook of this project; call find_runbooks to look one up. Only relevant to projects using ephemeral environments.DescriptionstringDiscreteChannelReleaseboolean
Treats releases of different channels to the same environment as a separate deployment dimension. ‘False’ indicates a “hotfix”-style usage of channels (single release active per environment ignoring channels), whereasTrueindicates “microservice”-style usage (single release per environment per channel).ExecuteDeploymentsOnEventBasedPipelinebooleanExtensionSettingsarray of objectExtensionIdstringValuesstring
ForcePackageDownloadbooleanIncludedLibraryVariableSetIdsarray of string
Library variable sets included in the project. Sets are listed in order of precedence, with earlier items in the list overriding any variables with the same name and scope definition appearing later in the list.IsBadgesEnabledbooleanIsDisabledbooleanLifecycleIdstring (required)Namestring (required)
Minimum length 1.PersistenceSettingsobjectTypeenum
Allowed values:Database,VersionControlled.
ProjectConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
ProjectGroupIdstring (required)ProjectIdstring (required)
ID of the project to modify.ProjectTagsarray of string
The project’s complete set of tags, each written as “TagSet/Tag” using either the names or the IDs of the tag set and tag (for example “Regions/us-east”). This replaces the project’s current tags, so resubmit the existing ones you want to keep. Call find_tag_sets to discover which tag sets apply to projects.ProvisioningRunbookIdstring
ID of a runbook in this project that provisions an ephemeral environment. Must be an existing runbook of this project; call find_runbooks to look one up. Only relevant to projects using ephemeral environments.ReleaseCreationStrategyobjectChannelIdstringReleaseCreationPackageobject
ReleaseNotesTemplatestringSlugstring
URL-friendly short identifier for the project, unique within the space. Leave unset to keep the project’s current slug.SpaceIdstring (required)Templatesarray of objectDefaultValueobjectDisplaySettingsobjectHelpTextstringIdstringLabelstringNamestring
TenantedDeploymentModeenum
Allowed values:Untenanted,TenantedOrUntenanted,Tenanted.VersioningStrategyobjectDonorPackageobjectTemplatestring
Response
200 — Confirms that the Project has been modified, containing the updated Project
AllowIgnoreChannelRulesbooleanAutoCreateReleasebooleanAutoDeployReleaseOverridesarray of objectEnvironmentIdstringReleaseIdstringTenantIdstring
ClonedFromProjectIdstringCombineHealthAndSyncStatusInDashboardLiveStatusbooleanDefaultGuidedFailureModeenum
Allowed values:EnvironmentDefault,Off,On.DefaultPowerShellEditionstringDefaultToSkipIfAlreadyInstalledbooleanDeploymentChangesTemplatestringDeploymentProcessIdstringDeprovisioningRunbookIdstringDescriptionstringDiscreteChannelReleaseboolean
Treats releases of different channels to the same environment as a seperate deployment dimension. ‘False’ indicates a “hotfix”-style usage of channels (single release active per environment ignoring channels), whereasTrueindicates “microservice”-style usage (single release per environment per channel).ExecuteDeploymentsOnEventBasedPipelinebooleanExtensionSettingsarray of objectExtensionIdstringValuesstring
ForcePackageDownloadbooleanIconobjectColorstring
Icon background colour, as a Hex string.Idstring
Font Awesome Icon Id.
Idstring
Gets or sets a unique identifier for this resource.IncludedLibraryVariableSetIdsarray of string
Library variable sets included in the project. Sets are listed in order of precedence, with earlier items in the list overriding any variables with the same name and scope definition appearing later in the list.IsBadgesEnabledbooleanIsDisabledbooleanIsVersionControlledbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LifecycleIdstringLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NamestringPersistenceSettingsobjectTypeenum
Allowed values:Database,VersionControlled.
ProjectConnectivityPolicyobjectAllowDeploymentsToNoTargetsbooleanExcludeUnhealthyTargetsbooleanSkipMachineBehaviorenum
Allowed values:None,SkipUnavailableMachines.TargetRolesarray of string
ProjectGroupIdstringProjectTagsarray of string
List of tags assigned to this project.ProjectTemplateDetailsobjectIsSharedbooleanSlugstringVersionMaskstring
Minimum length 1.
ProvisioningRunbookIdstringReleaseCreationStrategyobjectChannelIdstringReleaseCreationPackageobject
ReleaseNotesTemplatestringSlugstringSpaceIdstringTemplatesarray of objectDefaultValueobjectDisplaySettingsobjectHelpTextstringIdstringLabelstringNamestring
TenantedDeploymentModeenum
Allowed values:Untenanted,TenantedOrUntenanted,Tenanted.VariableSetIdstringVersioningStrategyobjectDonorPackageobjectTemplatestring
Example Request
{
"AllowIgnoreChannelRules": true,
"AutoCreateRelease": true,
"AutoDeployReleaseOverrides": [
{
"EnvironmentId": "string",
"ReleaseId": "string",
"TenantId": "Tenants-1"
}
],
"ChangeDescription": "string",
"ClonedFromProjectId": "Projects-1",
"CombineHealthAndSyncStatusInDashboardLiveStatus": true,
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultPowerShellEdition": "string",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"DeprovisioningRunbookId": "Runbooks-1",
"Description": "string",
"DiscreteChannelRelease": true,
"ExecuteDeploymentsOnEventBasedPipeline": true,
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"ForcePackageDownload": true,
"IncludedLibraryVariableSetIds": [
"string"
],
"IsBadgesEnabled": true,
"IsDisabled": true,
"LifecycleId": "Lifecycles-1",
"Name": "string",
"PersistenceSettings": {
"Type": "Database"
},
"ProjectConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"ProjectGroupId": "ProjectGroups-1",
"ProjectId": "Projects-1",
"ProjectTags": [
"string"
],
"ProvisioningRunbookId": "Runbooks-1",
"ReleaseCreationStrategy": {
"ChannelId": "string",
"ReleaseCreationPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
}
},
"ReleaseNotesTemplate": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Templates": [
{
"DefaultValue": {
"IsSensitive": true,
"SensitiveValue": {},
"Value": "string"
},
"DisplaySettings": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"HelpText": "string",
"Id": "string",
"Label": "string",
"Name": "string"
}
],
"TenantedDeploymentMode": "Untenanted",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Example Response
{
"AllowIgnoreChannelRules": true,
"AutoCreateRelease": true,
"AutoDeployReleaseOverrides": [
{
"EnvironmentId": "string",
"ReleaseId": "string",
"TenantId": "Tenants-1"
}
],
"ClonedFromProjectId": "Projects-1",
"CombineHealthAndSyncStatusInDashboardLiveStatus": true,
"DefaultGuidedFailureMode": "EnvironmentDefault",
"DefaultPowerShellEdition": "string",
"DefaultToSkipIfAlreadyInstalled": true,
"DeploymentChangesTemplate": "string",
"DeploymentProcessId": "string",
"DeprovisioningRunbookId": "Runbooks-1",
"Description": "string",
"DiscreteChannelRelease": true,
"ExecuteDeploymentsOnEventBasedPipeline": true,
"ExtensionSettings": [
{
"ExtensionId": "string",
"Values": "string"
}
],
"ForcePackageDownload": true,
"Icon": {
"Color": "string",
"Id": "string"
},
"Id": "string",
"IncludedLibraryVariableSetIds": [
"string"
],
"IsBadgesEnabled": true,
"IsDisabled": true,
"IsVersionControlled": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LifecycleId": "string",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"PersistenceSettings": {
"Type": "Database"
},
"ProjectConnectivityPolicy": {
"AllowDeploymentsToNoTargets": true,
"ExcludeUnhealthyTargets": true,
"SkipMachineBehavior": "None",
"TargetRoles": [
"string"
]
},
"ProjectGroupId": "string",
"ProjectTags": [
"string"
],
"ProjectTemplateDetails": {
"IsShared": true,
"Slug": "string",
"VersionMask": "string"
},
"ProvisioningRunbookId": "Runbooks-1",
"ReleaseCreationStrategy": {
"ChannelId": "string",
"ReleaseCreationPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
}
},
"ReleaseNotesTemplate": "string",
"Slug": "string",
"SpaceId": "Spaces-1",
"Templates": [
{
"DefaultValue": {
"IsSensitive": true,
"SensitiveValue": {},
"Value": "string"
},
"DisplaySettings": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"HelpText": "string",
"Id": "string",
"Label": "string",
"Name": "string"
}
],
"TenantedDeploymentMode": "Untenanted",
"VariableSetId": "string",
"VersioningStrategy": {
"DonorPackage": {
"DeploymentAction": "string",
"PackageReference": "string"
},
"Template": "string"
}
}Delete an existing Project
DELETE /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)
ID of the Project to delete.spaceIdstring (required)
Response
200 — Success
Test the Git settings to make sure we can connect
POST /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)spaceIdstring (required)
Request Body
BasePathstring (required)Credentialsobject (required)Typeenum
Allowed values:Anonymous,UsernamePassword,Reference,GitHub,SshKey.
DefaultBranchstring (required)ProjectIdstring (required)SpaceIdstring (required)Urlstring (required)
Minimum length 1.
Response
200 — The results from testing git settings.
Messagesarray of objectCategoryenum
Allowed values:Info,Error.Messagestring
Minimum length 1.
Example Request
{
"BasePath": "string",
"Credentials": {
"Type": "Anonymous"
},
"DefaultBranch": "string",
"ProjectId": "Projects-1",
"SpaceId": "Spaces-1",
"Url": "string"
}Example Response
{
"Messages": [
{
"Category": "Info",
"Message": "string"
}
]
}Convert an existing project to store its configuration in version control
POST /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
ChangeDescriptionstring (required)
Minimum length 1.CommitMessagestringInitialCommitBranchNamestringProjectIdstring (required)SpaceIdstring (required)
The ID of the space containing the resource(s).VersionControlSettingsobject (required)BasePathstring (required)ConversionStateobjectCredentialsobject (required)DefaultBranchstring (required)ProtectedBranchNamePatternsarray of stringProtectedDefaultBranchbooleanSerializationFormatenum
Allowed values:Ocl,Yaml.Typeenum (required)
Defaults toVersionControlled.
Allowed values:Database,VersionControlled.Urlstring (required)
Minimum length 1.
Response
200 — Empty response indicating the Project was converted
Example Request
{
"ChangeDescription": "string",
"CommitMessage": "string",
"InitialCommitBranchName": "string",
"ProjectId": "Projects-1",
"SpaceId": "Spaces-1",
"VersionControlSettings": {
"BasePath": "string",
"ConversionState": {
"RunbooksAreInGit": true,
"VariablesAreInGit": true
},
"Credentials": {
"Type": "Anonymous"
},
"DefaultBranch": "string",
"ProtectedBranchNamePatterns": [
"string"
],
"ProtectedDefaultBranch": true,
"SerializationFormat": "Ocl",
"Type": "Database",
"Url": "string"
}
}Example Response
{}Convert all Runbooks to be stored in Git rather than the database
POST /api
Also reachable at /api.
Path Parameters
projectIdstring (required)spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
Branchstring
Branch to commit the migrated Runbooks to. Required if there are Runbooks to migrate.CommitMessagestring
Commit message to use when committing the migrated Runbooks to Git. Required if there are Runbooks to migrate.CreateBranchbooleanProjectIdstring (required)SpaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — Indicates that the project runbooks were converted to Git
DraftRunbooksarray of objectRunbookIdstringRunbookNamestring
PublishedRunbooksarray of objectRunbookIdstringRunbookNamestring
ServerTaskIdstring
Example Request
{
"Branch": "string",
"CommitMessage": "string",
"CreateBranch": true,
"ProjectId": "Projects-1",
"SpaceId": "Spaces-1"
}Example Response
{
"DraftRunbooks": [
{
"RunbookId": "string",
"RunbookName": "string"
}
],
"PublishedRunbooks": [
{
"RunbookId": "string",
"RunbookName": "string"
}
],
"ServerTaskId": "ServerTasks-1"
}Update the logo associated with the project
POST /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)
The ID of the project to change logo for.spaceIdstring (required)
Response
200 — Success
Update the logo associated with the project
PUT /api
Path Parameters
projectIdstring (required)
The ID of the project to change logo for.spaceIdstring (required)
Response
200 — Success
Update the logo associated with the project
PUT /api
Also reachable at /api.
Path Parameters
projectIdstring (required)
The ID of the project to change logo for.spaceIdentifierstring (required)
Identifier (ID or slug) of the space.
Response
200 — Success
Get the custom settings metadata from the extensions
GET /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)spaceIdstring (required)
Response
200 — The custom settings metadata from the extensions.
ExtensionIdstring
Minimum length 1.MetadataobjectDescriptionstringTypesarray of object
Example Response
[
{
"ExtensionId": "string",
"Metadata": {
"Description": "string",
"Types": [
{}
]
}
}
]Get a summary of project-specific information
GET /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)
ID of the Project.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — The requested Project Summary
HasBeenSuccessfullyDeployedbooleanHasDeploymentProcessbooleanHasRunbooksboolean
Example Response
{
"HasBeenSuccessfullyDeployed": true,
"HasDeploymentProcess": true,
"HasRunbooks": true
}Get a summary of project-specific information
GET /api
Also reachable at /api, /api.
Path Parameters
projectIdstring (required)
ID of the Project.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — The requested Project Summary
HasBeenSuccessfullyDeployedbooleanHasDeploymentProcessbooleanHasRunbooksboolean
Example Response
{
"HasBeenSuccessfullyDeployed": true,
"HasDeploymentProcess": true,
"HasRunbooks": true
}Get a summary of project-specific information
GET /api
Also reachable at /api, /api.
Path Parameters
gitRefstring (required)projectIdstring (required)
ID of the Project.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — The requested Project Summary
HasBeenSuccessfullyDeployedbooleanHasDeploymentProcessbooleanHasRunbooksboolean
Example Response
{
"HasBeenSuccessfullyDeployed": true,
"HasDeploymentProcess": true,
"HasRunbooks": true
}Get a summary of project-specific information
GET /api
Also reachable at /api, /api.
Path Parameters
gitRefstring (required)projectIdstring (required)
ID of the Project.spaceIdstring (required)
The ID of the space containing the resource(s).
Response
200 — The requested Project Summary
HasBeenSuccessfullyDeployedbooleanHasDeploymentProcessbooleanHasRunbooksboolean
Example Response
{
"HasBeenSuccessfullyDeployed": true,
"HasDeploymentProcess": true,
"HasRunbooks": true
}Validate the provided git ref
POST /api
Also reachable at /api, /api.
Deprecated. This endpoint may be removed in a future release.
Path Parameters
projectIdstring (required)
ID of the Project.spaceIdstring (required)
Request Body
GitRefstring (required)ProjectIdstring (required)
ID of the Project.SpaceIdstring (required)
Response
200 — Validated Git ref or error message
ErrorstringValidatedGitRefobjectCanonicalNamestring
Minimum length 1.Idstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Minimum length 1.
Example Request
{
"GitRef": "string",
"ProjectId": "Projects-1",
"SpaceId": "Spaces-1"
}Example Response
{
"Error": "string",
"ValidatedGitRef": {
"CanonicalName": "string",
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string"
}
}